print("****************************************************************************")
print("          Programma a corredo del libro di testo                           *")
print(" Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
print("                                                                           *")
print("  CLIENT MQTT DI TIPO SUBSCRIBER CHE SI CONNETTE AL BROKER SPECIFICATO,    *")
print("  PUBBLICO: test.mosquitto.org                                             *")
print("  O PRIVATO (FORNENDO L'INDIRIZZO IP)                                      *")
print("  LEGGE I MESSAGGI E LI SCRIVE SU FILE                                     *")
print("                                                                           *")                   
print("****************************************************************************")
import paho.mqtt.client as mqtt #importa il client mqtt
import subprocess
import platform
import time
from sys import exit
import os
#
messaggio = ["","",""]
temperatura = ""
sist_operativo = platform.system()
############
#
def ping(indip):                    #funzione che esegue un ping sull'indirizzo IP passato come parametro
    if sist_operativo == "Windows":
       pinga = subprocess.run("ping -n 3 -w 200 " + indip).returncode  # fai 3 richieste di echo (la prima può fallire) con timeout di 500 ms
    else:
       pinga = subprocess.run(("ping " + indip + " -c 4 -w 300"), shell=True).returncode      # con LINUX funziona questo
    return pinga
############
def messaggi_ricevuti(client, userdata, message):
    #
    messaggio = str(message.payload.decode("utf-8"))
    print(messaggio)
    #print("topic:",message.topic)  #decommentare se per ogni dato ricevuto si vogliono visualizzare topic e qos
    #print("qos: ",message.qos)
    #print("message retain flag: ",message.retain)
    #----------------------------------------------------------------------------------------
    #per ogni messaggio ricevuti apri il file e appendi il messaggio stesso
    with open('valori_salvati'+ str(data) + "_ora_" + str(oranome) + "_.txt", "a") as file:  
        file.write(messaggio) #scrivi sul file il messaggio o i dati ricevuti
        file.write("\n")
    #----------------------------------------------------------------------------------------
#
orario = time.strftime("%H:%M")
oranome = time.strftime("%H_%M")
data = time.strftime("%d-%m-%Y")
print("+"*110 + "\n")
print ("Data: " + str(data) + "; Ora: " + str(orario) + "\n")
print("+"*110 + "\n")
#
#-------------------------------------------------------------
#
print("-" *100 + "\n")
print ("  Broker MQTT di default: test.mosquitto.org \n ")
print ("  Topic di default: LAB-IOT/ARDUINO-DHT11 \n")
print("-" *100 + "\n")
#
scelta = input("Vuoi fornire un nuovo broker MQTT e un nuovo topic? [s/n] ")
#
if scelta.lower() == "s":  #RENDI CASE INSENSITIVE
    print("\n")
    indirizzo_broker = input("Indirizzo del nuovo Broker MQTT:")
    print("\n")
    nome_topic= input("Nuovo topic: ")
    print("\n")
else:
    nome_topic="LAB-IOT/ARDUINO-DHT11"
    #indirizzo_broker=="10.10.7.254"  #broker privato
    indirizzo_broker="test.mosquitto.org"   #broker pubblico
print("-" *100 + "\n")
#
#verifica con un ping per verificare che il broker sia raggiungibile!!!!
print ("\n---------------------------------------------------------------------------------------------------\n")
print("Verifico con dei ping che il broker MQTT sia raggiungibile\n")
print("+"*110 + "\n")
esitoping = ping(indirizzo_broker)
if esitoping != 0:  # l'host NON ha risposto al ping segnala ciò e termina
   print ("---------------------------------------------------------------------------------------------------\n")
   print ("ATTENZIONE! Il BROKER MQTT " + indirizzo_broker + " non risponde, potrebbe essere spento o non collegato in rete")
   print ("Il programma viene terminato!\n")
   print ("---------------------------------------------------------------------------------------------------\n")
   exit()
#----------------------------------------------------------
# mettere un input che chiede se si vuole finire se la risposta è si esegue client.loop_stop()
print ("\n---------------------------------------------------------------------------------------------------\n")
print("ATTENZIONE! \n")
print("Il programma esegue un loop infinito. Chiudere il programma per terminare! \n")
print("+"*110 + "\n")
#
client = mqtt.Client("Client_python") #crea una nuova istanza
client.on_message=messaggi_ricevuti #chiama la funzione per leggere il messaggio
print("Connessione al broker: ",indirizzo_broker )
client.connect(indirizzo_broker) #connette al broker
print("Sottoscrizione ai topic: ",nome_topic)
print(" ")
print("+++++++++++++++++++++  MESSAGGI RICEVUTI  +++++++++++++++++++++++++++\n")
data_ora = "Inizio acquisizione. " + "Data "+ str(data) + "; ora " + str(orario)

with open('valori_salvati'+ str(data) + "_ora_" + str(oranome) + "_.txt", "a") as file:
        file.write("****************************************************************************\n")
        file.write("          Programma a corredo del libro di testo                           *\n")
        file.write(" Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *\n")
        file.write("****************************************************************************\n")
        file.write(data_ora)
        file.write("\n")
        file.write("-----------------------------------------------------------------------\n")
        file.write("Connessione al broker: ")
        file.write(indirizzo_broker)
        file.write("\n")
        file.write("Sottoscrizione ai topic: ")
        file.write(nome_topic)
        file.write("\n")
        file.write("+++++++++++++++++++++  MESSAGGI RICEVUTI  +++++++++++++++++++++++++++\n")
        file.write("\n")
client.subscribe(nome_topic)
time.sleep(4) # aspetta
client.loop_forever() # loop infinito





