#-----------------------------------------------------------------------------------------------------
print("\n****************************************************************************")
print("*          Programma a corredo del libro di testo                           *")
print("* Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
print("\n")
print("*"*100 +"\n")
print("Programma in Python 3.x per la esemplificare l'impiego del modulo telnetlib\n")
print("*"*100 +"\n")
print(" Programma realizzato da Onelio Bertazioli \n")
print("*"*100 +"\n")

import telnetlib  #importa il modulo telnetlib
from sys import exit
#
ip_remoto = "10.0.0.223"  #cambiare nell'indirizzo IP del dispositivo remoto se è diverso da questo
utente = b"studente"  #nome utente in byte (b)
password = b"telecom"  #password in byte (b)
#
print("Verifica versione s.o. e configurazione IP del dispositivo: " + ip_remoto + "\n")
usatelnet = telnetlib.Telnet()              # avvia un'istanza del modulo telnetlib
usatelnet.open(ip_remoto)                   #richiede la connessione al dispositivo remoto
usatelnet.read_until(b"login: ")# attendi la richiesta di login
usatelnet.write(utente + b"\n")             #invia il nome utente (come byte)
usatelnet.read_until(b"Password: ")         # attendi la richiesta della password
usatelnet.write(password + b"\n")           #invia la password (come byte)
usatelnet.read_until(b"$")                  #attendi il prompt dei comandi   
usatelnet.write(b"uname -a" + b"\n")        #invia il comando per ottenere la versione del s.o.
s_o=(usatelnet.read_until(b"$").decode())   #salva la risposta e mettila in formato stringa (.decode())
usatelnet.write(b"ip address\n")            #invia il comando per ottenere la configurazione ip
conf_ip=(usatelnet.read_until(b"$")).decode() #salva la risposta e mettila in formato stringa (.decode())
usatelnet.write(b"exit\n")        #invia il comando per chiudere la connessione telnet
print(s_o)
print(conf_ip)
print("\n")
fine=input("Premere Invio per uscire")
exit()
