#-----------------------------------------------------------------------------------------------------
print("\n****************************************************************************")
print("*          Programma a corredo del libro di testo                           *")
print("* Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-----------------------------------------------------------------------------------------------------
print("\n")
print("*"*100 +"\n")
print("Programma in Python 3.x per la esemplificare l'impiego del modulo netmiko\n")
print("*"*100 +"\n")
print(" Programma realizzato da Onelio Bertazioli \n")
print("*"*100 +"\n")
#
from netmiko import ConnectHandler # importa il modulo che gestisce la connessione via SSH 
#
ip_remoto = "10.0.0.223"
utente = "studente"
password = "telecom"
#  apri una connessione SSH con il dispositivo remoto
print("\nSto aprendo la connessione, attendi!\n")
usa_SSH = ConnectHandler(device_type='linux', ip = ip_remoto, username = utente, password = password)
prompt = usa_SSH.find_prompt() #acquisisci il prompt dei comandi (opzionale)
comando1 =  "uname -a" + "\n"
risposta1 = usa_SSH.send_command(comando1) #invia il 1o comando e memorizza la risposta
comando2 =  "ip address" + "\n"
risposta2 = usa_SSH.send_command(comando2) #invia il 2o comando e memorizza la risposta
print("Prompt del dispositivo remoto: "+ prompt + "\n")
print ("Versione del sistema operativo del dispositivo " + ip_remoto + " \n" )
print (risposta1+"\n")
print ("Configurazione IP del dispositivo " + ip_remoto + " \n" )
print (risposta2+"\n")
fine=input("\nPremere Invio per uscire")
