#-----------------------------------------------------------------------------------------------------
print("\n****************************************************************************")
print("*          Programma a corredo del libro di testo                           *")
print("* Onelio Bertazioli - Telecomunicazioni Seconda edizione - ed- Zanichelli   *")
print("****************************************************************************")
#-------------------------------------------------------------------------------------------------------------------------------------
print("\n")
print("*"*100 +"\n")
print("Programma in Python 3.X per la ricerca del costruttore di n schede di rete di cui è noto l'indirizzo MAC\n")
print("il file contiene un indirizzo mac per ogni riga: \n")
print("Esempio: ")
print("aa:bb:cc:00:ab:a0")
print("aa:bb:cc:00:ab:b0")
print(".................")
print("\nNel file si può anche mettere solo l'id mac del costruttore: aa:bb:cc")
print("*"*100 +"\n")
print(" Programma realizzato da Onelio Bertazioli \n")
print("*"*100 +"\n")
#---------------------------------------------------------------------------------------------------------------------------------------
from sys import exit
import os
import requests
#-------------------------------------------------------------------------------------------------------------------------
def cercavendor(mac):  # funzione che determina il vendor della scheda con il mac indicato
    #
    url = "http://macvendors.co/api/" + mac + "/csv"   #nell'url chiedi che la risposta sia una stringa in formato .csv
    risposta = requests.get(url)                       #chiedi come risposta il costruttore della scheda di cui si fornisce il mac
    risposta = risposta.text   #metti in risposta il testo della risposta
    risposta = risposta.replace('"', "")   # elimina dalla risposta tutti i doppi apici
    #
    k=0
    for n in risposta:    #cerca in risposta la prima virgola contando i caratteri che intercorrono
        if n != ",":
            k = k+1
        elif n == ",":
            vendor = risposta[0:k]  # tutti i caratteri prima della virgola sono il nome del costruttore (vendor) 
            break
    #
    return  vendor     #la funzione restituisce la stringa vendor che contiene il nome del costruttore 
#---------------------------------------------------------------------------------------------------------
continua = "n"
while continua == "n":
    
     nomefile = input("Nome del file con gli indirizzi mac: ")
     try:
         file = open(nomefile)      #apri il file e mettine il contenuto nella variabile file
         continua = "s"
     except IOError:
         print ("+" *100 + "\n")
         print ("    Attenzione! Il file " + nomefile + " non esiste! \n")
         riprova = input("Vuoi riprovare [s/n]? ")
         print ("\n")
         print ("+" *100 + "\n")
         if riprova == "n":
             fine = input(" Premere un tasto per terminare il programma!")
             exit()
         elif riprova == "N":
              fine = input(" Premere un tasto per terminare il programma!")
              exit()
         #esci()

nome = nomefile[0:len(nomefile)-4]
#
scrivi =open(nome + "_vendor_.txt", "w")
lista_mac = []
x=0
for line in file:
    x=x+1
lunghezza = x
file.close()
#
file = open(nomefile, 'r')
k=0
while k<lunghezza:
    #
    mac = file.readline()
    mac = mac.strip("\n")
    #
    lista_mac.append(mac)
    k=k+1
#
file.close()
print( "\nAttendere, sto cercando i vendor!\n")
print("\n")
print( "Indirizzo MAC          Costruttore \n")
scrivi.write( "Indirizzo MAC          Costruttore \n")
scrivi.write("\n")
for mac in lista_mac:
    vendor = cercavendor(mac)
    print(mac + "   " + vendor + "\n")
    scrivi.write(mac + "   " + vendor + "\n")
    scrivi.write("\n")
scrivi.close()
print("\n"+100*"*")
print("\nIl programma ha finito la ricerca!")    
exit()
